/*
 * GIF support.
 * Uses gif library by Gershon Elber and Eric S. Raymond.
 * Read file "PIXMAPS.README" for more info.
 */

#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <unistd.h>
#include <string.h>
#include <gif_lib.h>

#include "hr_defines.h"
#include "hr_general.h"
#include "hr_bobs.h"
#include "hr_bitmaps.h"


/* Reads an GIF image from disk and returns pointer to
 * bitmap, or NULL if an error occurred.*/
/* FIX! Make use of hr_bitmap_colors() */
struct hr_bitmap *hr_read_gif(unsigned char *name,int flags)
{
	GifFileType *ftype;
	struct hr_bitmap *bmap;
	unsigned char *data=NULL;
	unsigned char *palette=NULL;
	int width,height,colors,c;
	/* Open the GIF file */
	if((ftype=DGifOpenFileName((char *)name))){
		/* Read the GIF image*/
		if(DGifSlurp(ftype)==GIF_OK){
			/* Get some info from the image */
			width=ftype->Image.Width;
			height=ftype->Image.Height;
			colors=ftype->SColorMap->ColorCount;
			if(flags & GFX_COLOR)
			  data=malloc(width*height);	/* FIX! Add check. */
			else if(flags & GFX_MONO)
			  data=calloc(1+(width*height)/8,1);   /* FIX! Add check. */
			palette=malloc(3*colors);	/* FIX! Add check. */
#if 0
			/* FIX! Add error handling.*/
			else
			  printf("ERROR!\n");
#endif
			/* Create HobbiRewl bitmap */
			if((bmap=hr_create_bitmap(data,palette,
											  width,height,colors,flags))){
				if(flags & GFX_COLOR){
					memcpy(bmap->data,ftype->SavedImages[0].RasterBits,
							 width*height);
					for(c=0;c<colors;c++){
						*(palette+c*3)=(ftype->SColorMap->Colors[c].Red)/4;
						*(palette+c*3+1)=(ftype->SColorMap->Colors[c].Green)/4;
						*(palette+c*3+2)=(ftype->SColorMap->Colors[c].Blue)/4;
					}
				}
				else if(flags & GFX_MONO){
					for(c=0;c<width*height;c++){
						if((ftype->SavedImages[0].RasterBits[c/8])&&(128>>(c%8))){
							*(data+c/8) |= 128>>(c%8);
							printf("#");		/* Remove */
						}
						else
						  printf(".");			/* Remove */
					}
				}
				/* Close the GIF file.*/
				if(DGifCloseFile(ftype)==GIF_OK)
				  return bmap;
				else{
					/* Something went wrong when closing file!*/
					hr_delete_bitmap(bmap);
				}
			}
		}
	}
	return NULL;
}
